// Exo 3
clear
deff('[y]=f(x)','y=x-sin(x)-3*%pi/2')

deff('[y]=g(x)','y=sin(x)+3*%pi/2')

s=fsolve(5,f)
x=0:0.01:10;
plot(x,f(x))
plot(x,zeros(x))
plot(s, 0,'*')

// Dichotomie
x1=-10;x2=5;
erreur=abs(s-x2);
compt=1;
while abs(x1-x2)>10^(-6)
  compt=compt+1;
  mil=(x1+x2)/2;
  if f(x1)*f(mil)<=0
    x2=mil;
  else
    x1=mil;
  end
  erreur=[erreur abs(s-x2)];
end
x2
erreur($)
figure(2);
clf
plot(1:compt,erreur)

//3)
// Approximations successives
x1=2;
x=g(x1);
xold=x1;
erreur1=abs(x-s);
compt=1;
XPF=[x1 x];
while abs(x-xold)>1e-6
  compt=compt+1;
  xold=x;
  x=g(x);
  XPF=[XPF x];
  erreur1=[erreur1 abs(x-s)];
end
x
plot(1:compt,erreur1,'r')

// Secante
x1=-10;x2=5;
compt=0;
xold=x1;
x=x2;
erreur2=[];
while abs(x-xold)>1e-6
  compt=compt+1;
  xloc=x;
  x=x-(x-xold)/(f(x)-f(xold))*f(x);
  xold=xloc;
  erreur2=[erreur2 abs(x-s)];
end
plot(1:compt,erreur2,'k')

//Newton
x1=2;
deff('[y]=h(x)','y=1-cos(x)')

x1=2;
xold=x1;
x=x1-f(x1)/h(x1);
erreur3=abs(x-s);
compt=1;
XNewt=[x1 x];
while abs(x-xold)>1e-6
  compt=compt+1;
  xold=x;
  x=x-f(x)/h(x);
  XNewt=[XNewt x];
  erreur3=[erreur3 abs(s-x)];
end
plot(1:compt,erreur3,'g')

figure(2);
clf;
subplot(1,4,1)
plot2d(erreur(1:$-1),erreur(2:$),logflag="ll")
subplot(1,4,2)
plot2d(erreur1(1:$-1),erreur1(2:$),logflag="ll")
subplot(1,4,3)
plot2d(erreur2(1:$-1),erreur2(2:$),logflag="ll")
subplot(1,4,4)
plot2d(erreur3(1:$-1),erreur3(2:$),logflag="ll")

[penteDich,C]=reglin(log(erreur(1:$-1)),log(erreur(2:$)))
[pentePF,C]=reglin(log(erreur1(1:$-1)),log(erreur1(2:$)))
[penteSec,C]=reglin(log(erreur2(1:$-1)),log(erreur2(2:$)))
[penteNewt,C]=reglin(log(erreur3(1:$-2)),log(erreur3(2:$-1)))


// 5)
figure(3);
clf;
xplot1=0:0.01:10;
plot2d(xplot1,g(xplot1))
plot2d(xplot1,xplot1)
n=length(XPF);
xplot(1:2:2*n)=XPF;
xplot(2:2:2*n)=XPF;
yplot(1:2:2*n)=XPF;
yplot(2:2:2*n)=[XPF(2:$) g(XPF($))];
plot2d(xplot,yplot,-1)
plot2d(xplot,yplot)
title('Approximations successives')

figure(4);
clf;
plot2d(xplot1,f(xplot1))
plot2d(xplot1,zeros(xplot1))
n=length(XNewt);
xplotN(1:2:2*n)=XNewt;
xplotN(2:2:2*n)=XNewt;
yplotN(1:2:2*n)=zeros(XNewt);
yplotN(2:2:2*n)=f(XNewt);
plot2d(xplotN,yplotN,-1)
plot2d(xplotN,yplotN)

title('Methode de Newton')







  
  
  
  
  
  
  
  
  
  
  